// 詳細なドキュメントおよびサンプルは以下のページをご覧ください
// https://smdn.jp/works/libs/Smdn.Net.Pop3.Client/docs/

using System;
using System.Security.Authentication;
using Smdn.Net.Pop3.Client;

class MainClass {
  static void Main(string[] args)
  {
    // SSL/TLSでの接続を行う場合は、証明書の検証を行うように書き換えてください
    PopSslConnection.ServerCertificateValidationCallback = PopSslConnection.DangerousAcceptAnyServerCertificateValidator;

    // 有効にするSSL/TLSプロトコルバージョンを指定する場合は、SslProtocolsの値を変更してください
    PopSslConnection.EnabledSslProtocols = SslProtocols.Default;

    const string hostname = "pop.example.net";
    const string username = "user";
    const string password = "pass";

    using (var client = new PopClient(new Uri($"pop://{username}@{hostname}/"))) {
      client.Profile.UseTlsIfAvailable = true;    // 可能ならSSL/TLSでの接続を行う
      client.Profile.AllowInsecureLogin = false;  // 平文での認証を許可しない

      // POPサーバーへの接続を行う
      client.Connect(password);

      Console.WriteLine("connected!!");

      // メールボックス内のメッセージ数を表示
      Console.WriteLine("message count: {0}", client.MessageCount);

      client.DeleteAfterRetrieve = false; // ダウンロードしたメッセージを削除しない

      // 最後に受信したメッセージをダウンロードしてファイルmessage.emlに保存する
      client.DownloadLastMessageToFile("message.eml");

      client.Logout();
    }
  }
}
